function [gamma_hat,rho_hat]=ZhuBradic_fast_estimator(W_tilde,Z,a1,a2,rho0)

[n,pp]=size(W_tilde);
ff=[ones(2*pp,1);0];
SS=W_tilde'*W_tilde/n;
bbb=W_tilde'*Z/n;
A=[-SS,SS,-a1*ones(pp,1);SS,-SS,-a1*ones(pp,1);bbb',-bbb',a2];
bb=[-bbb;bbb;Z'*Z/n];
lb=[zeros(2*pp,1);rho0];
ub=[inf(2*pp,1);1];
[output, ~, ~] = linprog_Gurobi(ff, A, bb, [], [], lb, ub);
gamma_hat=output(1:pp)-output(pp+1:2*pp);
rho_hat=output(end);